Index: src/edu/ucsb/nceas/metacat/DBDTDHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBDTDHandler.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/DBDTDHandler.java	(revision 4080)
@@ -88,6 +88,9 @@
     * Return empty string if there are not 
     */
 /*
+ * If this ever gets uncommented, you will need to verify the 
+ * server url on the front of the system ID.
+ * 
    private String getEntitySystemID (Connection conn, String doctype, 
                                      String publicId)
    {
Index: src/edu/ucsb/nceas/metacat/ReplicationServerList.java
===================================================================
--- src/edu/ucsb/nceas/metacat/ReplicationServerList.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/ReplicationServerList.java	(revision 4080)
@@ -28,6 +28,8 @@
 package edu.ucsb.nceas.metacat;
 
 import edu.ucsb.nceas.dbadapter.AbstractDatabase;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
+
 import java.util.Vector;
 import java.sql.*;
 
Index: src/edu/ucsb/nceas/metacat/Sitemap.java
===================================================================
--- src/edu/ucsb/nceas/metacat/Sitemap.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/Sitemap.java	(revision 4080)
@@ -35,6 +35,9 @@
 
 import org.apache.log4j.Logger;
 
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+
 /**
  * A Sitemap represents a document that lists all of the content of the Metacat
  * server for use by harvesting spiders that wish to index the contents of the
@@ -140,7 +143,7 @@
                         writeSitemapHeader(sitemap);
                     }
 
-                    String separator = MetaCatUtil.getOption("accNumSeparator");
+                    String separator = PropertyService.getProperty("accNumSeparator");
                     String docid = rs.getString(1) + separator
                             + rs.getString(2);
                     writeSitemapEntry(sitemap, docid);
@@ -154,6 +157,9 @@
             } catch (IOException ioe) {
                 logMetacat.warn("Could not open or write to the sitemap file."
                         + ioe.getMessage());
+            } catch (PropertyNotFoundException pnfe) {
+                logMetacat.warn("Could not retrieve the account number separator."
+                        + pnfe.getMessage());
             } finally {
                 // Return database connection to the pool
                 DBConnectionPool.returnDBConnection(dbConn, serialNumber);
Index: src/edu/ucsb/nceas/metacat/admin/AdminException.java
===================================================================
--- src/edu/ucsb/nceas/metacat/admin/AdminException.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/admin/AdminException.java	(revision 4080)
@@ -0,0 +1,46 @@
+/**
+ *  '$RCSfile$'
+ *    Purpose: An Exception thrown when an error occurs because an 
+ *             AccessionNumber was invalid or used incorrectly
+ *  Copyright: 2008 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *    Authors: Michael Daigle
+ *
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacat.admin;
+
+/**
+ * Exception thrown when an error occurs in a configuration administrative
+ * class
+ */
+public class AdminException extends Exception {
+	
+	private static final long serialVersionUID = -7190381642745794017L;
+
+	/**
+	 * Create a new AdminException.
+	 *
+	 * @param message The error or warning message.
+	 */
+	public AdminException(String message) {
+		super(message);
+	}
+}

Index: src/edu/ucsb/nceas/metacat/admin/MetaCatAdminServlet.java
===================================================================
--- src/edu/ucsb/nceas/metacat/admin/MetaCatAdminServlet.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/admin/MetaCatAdminServlet.java	(revision 4080)
@@ -0,0 +1,190 @@
+/**
+ *  '$RCSfile$'
+ *    Purpose: A Class that implements utility methods for a metadata catalog
+ *  Copyright: 2008 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *    Authors: Michael Daigle
+ *
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacat.admin;
+
+import java.io.IOException;
+import java.util.Vector;
+
+import javax.servlet.ServletConfig;
+import javax.servlet.ServletException;
+import javax.servlet.http.HttpServlet;
+import javax.servlet.http.HttpServletRequest;
+import javax.servlet.http.HttpServletResponse;
+import javax.servlet.http.HttpSession;
+
+import org.apache.log4j.Logger;
+
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.service.SessionService;
+import edu.ucsb.nceas.metacat.util.LDAPUtil;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
+import edu.ucsb.nceas.metacat.util.RequestUtil;
+import edu.ucsb.nceas.metacat.util.SkinUtil;
+import edu.ucsb.nceas.metacat.util.SystemUtil;
+import edu.ucsb.nceas.metacat.util.UtilException;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+
+/**
+ * Entry servlet for the metadata configuration utility
+ */
+public class MetaCatAdminServlet extends HttpServlet {
+
+	private static final long serialVersionUID = 1L;
+	
+	private Logger logMetacat = Logger.getLogger(MetaCatAdminServlet.class);
+	
+    /**
+	 * Initialize the servlet
+	 */
+	public void init(ServletConfig config) throws ServletException {
+		super.init(config);
+	}
+        
+    /** Handle "GET" method requests from HTTP clients */
+	public void doGet(HttpServletRequest request, HttpServletResponse response)
+			throws ServletException, IOException {
+
+		// Process the data and send back the response
+		handleGetOrPost(request, response);
+	}
+
+	/** Handle "POST" method requests from HTTP clients */
+	public void doPost(HttpServletRequest request, HttpServletResponse response)
+			throws ServletException, IOException {
+
+		// Process the data and send back the response
+		handleGetOrPost(request, response);
+	}
+       
+    /**
+	 * Control servlet response depending on the action parameter specified
+	 * 
+	 * @param request
+	 *            the http request information
+	 * @param response
+	 *            the http response to be sent back to the client
+	 */
+	private void handleGetOrPost(HttpServletRequest request,
+			HttpServletResponse response) throws ServletException, IOException {
+		String action = request.getParameter("configureType");
+		logMetacat.debug("Processing admin action: " + action);
+		Vector<String> processingMessage = new Vector<String>();
+		Vector<String> processingErrors = new Vector<String>();
+
+		try {
+			// Update the last update time for this user if they are not new
+			HttpSession httpSession = request.getSession(false);
+			if (httpSession != null) {
+				SessionService.touchSession(httpSession.getId());
+			}
+			
+			// if ldap isn't configured, change the action to ldap.  ldap
+			// needs to be set up before we do anything else
+			if (!LDAPUtil.isLDAPConfigured()) {
+				processingMessage.add("You must configure LDAP before "
+						+ "you can continue with MetaCat configuration.");
+				RequestUtil.setRequestMessage(request, processingMessage);
+				action = "ldap";
+				logMetacat.debug("Admin action changed to 'ldap'");
+			}
+
+			// Once ldap is configured, see if the user is logged in
+			// as an administrator.  If not, they need to log in before
+			// they can continue with configuration.
+			if (LDAPUtil.isLDAPConfigured()
+					&& !LDAPUtil.isUserLoggedInAsAdmin(request)) {
+				processingMessage.add("You must log in as an administrative " + "" +
+						"user before you can continue with MetaCat configuration.");
+				RequestUtil.setRequestMessage(request, processingMessage);
+				action = "login";
+				logMetacat.debug("Admin action changed to 'login'");
+			}
+
+			if (action == null || action.equals("configure")) {
+				// Forward the request main configuration page
+				request.setAttribute("metaCatVersion", SystemUtil.getMetacatVersion()); 
+			    request.setAttribute("propsConfigured", new Boolean(PropertyService.arePropertiesConfigured()));
+			    if (PropertyService.arePropertiesConfigured()) {
+					request.setAttribute("databaseVersion", 
+							DBAdmin.getInstance().getDBVersion());
+				}
+			    request.setAttribute("ldapConfigured", new Boolean(LDAPUtil.isLDAPConfigured()));	
+			    request.setAttribute("skinsConfigured", new Boolean(SkinUtil.areSkinsConfigured()));
+			    request.setAttribute("metacatConfigured", new Boolean(MetaCatUtil.isMetacatConfigured()));	
+				RequestUtil.forwardRequest(request, response,
+						"/admin/metacat-configuration.jsp?configureType=configure");
+				return;
+			} else if (action.equals("properties")) {
+				// process properties
+				PropertiesAdmin.getInstance().configureProperties(request,
+						response);
+				return;
+			} else if (action.equals("skins")) {
+				// process skins
+				SkinsAdmin.getInstance().configureSkins(request, response);
+				return;
+			} else if (action.equals("database")) {
+				// process properties
+				DBAdmin.getInstance().configureDatabase(request, response);
+				return;
+			} else if (action.equals("ldap")) {
+				// process properties
+				LDAPAdmin.getInstance().configureLDAP(request, response);
+				return;
+			} else if (action.equals("login")) {
+				// process properties
+				AuthAdmin.getInstance().authenticateUser(request, response);
+				return;
+			} else {
+				String errorMessage = "Invalid action in configuration request: " + action;
+				logMetacat.error(errorMessage);
+				processingErrors.add(errorMessage);
+			}
+		} catch (PropertyNotFoundException pnfe) {
+			String errorMessage = 
+				"Property problem while handling request: " + pnfe.getMessage();
+			logMetacat.error(errorMessage);
+			processingErrors.add(errorMessage);
+		} catch (AdminException ae) {
+			String errorMessage = 
+				"Admin problem while handling request: " + ae.getMessage();
+			logMetacat.error(errorMessage);
+			processingErrors.add(errorMessage);
+		} catch (UtilException ue) {
+			String errorMessage = 
+				"Utility problem while handling request: " + ue.getMessage();
+			logMetacat.error(errorMessage);
+			processingErrors.add(errorMessage);
+		}
+		
+		if (processingErrors.size() > 0) {
+			RequestUtil.clearRequestMessages(request);
+			RequestUtil.setRequestErrors(request,processingErrors);
+			RequestUtil.forwardRequest(request, response, "/admin/metacat-configuration.jsp");
+		}
+	}       	
+}
\ No newline at end of file

Index: src/edu/ucsb/nceas/metacat/SchemaLocationResolver.java
===================================================================
--- src/edu/ucsb/nceas/metacat/SchemaLocationResolver.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/SchemaLocationResolver.java	(revision 4080)
@@ -44,6 +44,9 @@
 
 import org.apache.log4j.Logger;
 
+import edu.ucsb.nceas.metacat.util.SystemUtil;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+
 /**
  * A database aware Class to handle schema location. If namespace is in the
  * xml_catalog table (public_id), the schema location specified in xml document
@@ -126,80 +129,79 @@
  
   }
 
-  /* This method will take look xml_catalog table and create a string look like
-   * "namespace1 location namespacke2 location". This string will be set as 
-   * a extenalschemalocation in SAX parser. Then when parser check the 
-   * it will ignore the schema location specified by xml document
-   */
-  private void createNameSpaceAndLocationStringFromDB()
-  {
-    DBConnection conn = null;
-    int serialNumber = -1;
-    PreparedStatement pstmt = null;
-    ResultSet result = null;
-    String sql = "SELECT public_id, system_id FROM xml_catalog where " +
-                 "entry_type ='" + DocumentImpl.SCHEMA +"'";
-    try 
-    {
-      //check out DBConnection
-      conn=DBConnectionPool.getDBConnection("SchemaLocationResl.createName");
-      serialNumber=conn.getCheckOutSerialNumber();
-      pstmt = conn.prepareStatement(sql);
-      pstmt.execute();
-      result = pstmt.getResultSet();
-      
-      // Get string for namespace and location form DB
-      boolean hasRow = result.next();
-      StringBuffer buffer = new StringBuffer();
-      boolean firstTime = true;
-      while (hasRow)
-      {
-        String namespace = result.getString(1);
-        String location  = result.getString(2);
-        String pairOfNameSpaceAndLocation = namespace + WHITESPACESTRING 
-                                            +location;
-        if (!firstTime)
-        {
-          buffer.append(WHITESPACESTRING);
-        }
-        buffer.append(pairOfNameSpaceAndLocation);
-        firstTime = false;
-        hasRow = result.next();
-        
-      }
-      // give the buffer to the string if buffer has something in it
-      if (buffer.length() != 0)
-      {
-        nameSpaceAndLocationString = buffer.toString();
-      }
-      result.close();
-      pstmt.close();
-    } 
-    catch (SQLException e) 
-    {
-      logMetacat.error("schemaLocation.createNameSpaceAndLocationString: " + 
-                         e.getMessage());
-    }
-    finally
-    {
-      try
-      {
-        pstmt.close();
-      }//try
-      catch (SQLException sqlE)
-      {
-        logMetacat.error("Error in schema.createNameSpaceAndLocation "
-                                    + sqlE.getMessage());
-      }//catch
-      DBConnectionPool.returnDBConnection(conn, serialNumber);
-    }//finally
-    
+  /*
+	 * This method will take look xml_catalog table and create a string look
+	 * like "namespace1 location namespacke2 location". This string will be set
+	 * as a extenalschemalocation in SAX parser. Then when parser check the it
+	 * will ignore the schema location specified by xml document
+	 */
+	private void createNameSpaceAndLocationStringFromDB() {
+		DBConnection conn = null;
+		int serialNumber = -1;
+		PreparedStatement pstmt = null;
+		ResultSet result = null;
+		String sql = "SELECT public_id, system_id FROM xml_catalog where "
+				+ "entry_type ='" + DocumentImpl.SCHEMA + "'";
+		try {
+			// check out DBConnection
+			conn = DBConnectionPool.getDBConnection("SchemaLocationResl.createName");
+			serialNumber = conn.getCheckOutSerialNumber();
+			pstmt = conn.prepareStatement(sql);
+			pstmt.execute();
+			result = pstmt.getResultSet();
 
-  }
+			// Get string for namespace and location form DB
+			boolean hasRow = result.next();
+			StringBuffer buffer = new StringBuffer();
+			boolean firstTime = true;
+			while (hasRow) {
+				String namespace = result.getString(1);
+				String location = result.getString(2);
+				// system id may not have server url on front. Add it if not.
+				if (!location.startsWith("http://")) {
+					try {
+						location = SystemUtil.getServerURL() + location;
+					} catch (PropertyNotFoundException pnfe) {
+						throw new SQLException("Could not find property: "
+								+ pnfe.getMessage());
+					}
+				}
+				String pairOfNameSpaceAndLocation = namespace + WHITESPACESTRING
+						+ location;
+				if (!firstTime) {
+					buffer.append(WHITESPACESTRING);
+				}
+				buffer.append(pairOfNameSpaceAndLocation);
+				firstTime = false;
+				hasRow = result.next();
 
-  /* This method will take look xml_catalog table and create a name space
-   * vector already in the table
-   */
+			}
+			// give the buffer to the string if buffer has something in it
+			if (buffer.length() != 0) {
+				nameSpaceAndLocationString = buffer.toString();
+			}
+			result.close();
+			pstmt.close();
+		} catch (SQLException e) {
+			logMetacat.error("schemaLocation.createNameSpaceAndLocationString: "
+					+ e.getMessage());
+		} finally {
+			try {
+				pstmt.close();
+			}// try
+			catch (SQLException sqlE) {
+				logMetacat.error("Error in schema.createNameSpaceAndLocation "
+						+ sqlE.getMessage());
+			}// catch
+			DBConnectionPool.returnDBConnection(conn, serialNumber);
+		}// finally
+
+	}
+
+  /*
+	 * This method will take look xml_catalog table and create a name space
+	 * vector already in the table
+	 */
   private void createNameSpaceListFromDB()
   {
     DBConnection conn = null;
@@ -258,8 +260,8 @@
   private String uploadSchemaFromURL(InputStream istream) throws Exception
   {
    
-    String schemaPath = MetaCatUtil.getOption("schemaPath");
-    String schemaURL = MetaCatUtil.getOption("schemaURL");
+    String schemaPath = SystemUtil.getContextDir() + "/schema/";
+    String schemaURL = SystemUtil.getContextURL()  + "/schema/";
 
     // get filename from systemId
     String filename = schemaLocation;
Index: src/edu/ucsb/nceas/metacat/RemoteDocument.java
===================================================================
--- src/edu/ucsb/nceas/metacat/RemoteDocument.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/RemoteDocument.java	(revision 4080)
@@ -26,6 +26,8 @@
 
 package edu.ucsb.nceas.metacat;
 
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
 import edu.ucsb.nceas.utilities.HttpMessage;
 import javax.servlet.ServletOutputStream;
 
@@ -90,7 +92,7 @@
     userName = myUserName;
     passWord = myPassWord;
     zipEntry = myZipEntryPath+ docIdWithoutRevision + 
-                MetaCatUtil.getOption("accNumSeparator") + revision;
+                PropertyService.getProperty("accNumSeparator") + revision;
    
 
   }// Constructor
@@ -205,7 +207,7 @@
       throw new Exception ("Couldn't find a dataset docid for the required id");
     }
     // Create a documentImpl object
-    String accNumber = givenDocId + MetaCatUtil.getOption("accNumSeparator") +
+    String accNumber = givenDocId + PropertyService.getProperty("accNumSeparator") +
     DBUtil.getLatestRevisionInDocumentTable(givenDocId);
     document = new DocumentImpl(accNumber, false);
     // get the replication home server (it come from xml_replication table)
@@ -293,7 +295,7 @@
     }
     // User specified docid (including revision number
     String specifiedDocId = docIdWithoutRevision + 
-                MetaCatUtil.getOption("accNumSeparator") +revision;
+                PropertyService.getProperty("accNumSeparator") +revision;
     logMetacat.info("The requried docid is: "+ specifiedDocId);
     
     // At first login to remote metacat server. 
@@ -364,7 +366,7 @@
     }
     // User specified docid (including revision number
     String specifiedDocId = docIdWithoutRevision + 
-                MetaCatUtil.getOption("accNumSeparator") +revision;
+                PropertyService.getProperty("accNumSeparator") +revision;
     logMetacat.info("The requried docid is: "+ specifiedDocId);
     
     // At first login to remote metacat server.
